View Issue Details

IDProjectCategoryView StatusLast Update
0001791Far ManagerFile Systempublic2011-12-23 08:58
ReporterDV Assigned To2useven10  
PrioritynormalSeverityminorReproducibilityalways
Status closedResolutionfixed 
PlatformanyOSany 
Product Version3.0 
Fixed in Version3.0 
Summary0001791: "Cannot find the file" по F5 после Ctrl+Tab из сохранённого в редакторе файла
DescriptionВзято из http://forum.farmanager.com/viewtopic.php?f=9&t=6259
При попытке копирования файла, который открыт в редакторе и был предварительно изменён и сохранён, получаем ошибку "Cannot find the file"
Steps To Reproduce1) Имеем файл abc.txt в левой панели и файл def.txt в правой:

    ╔═══════════ C:\123 ═══════════╗╔═══════════ D:\456 ═══════23:54
    ║n Name │ Name ║║n Name │ Name ║
    ║.. │ ║║.. │ ║
    ║abc.txt │ ║║def.txt │ ║
    ║ │ ║║ │ ║
    ║ │ ║║ │ ║


2) Выбираем файл def.txt на правой панели и жмем F4
3) Переключаемся в панели из редактора (Ctrl+Tab), переходим на левую панель (Tab) и выбираем файл abc.txt
4) Переключаемся из панелей назад в редактор (Ctrl+Tab), что-нибудь меняем в файле и жмем сохранить (F2)
5) Переключаемся в панели из редактора (Ctrl+Tab) и жмем F5 (копировать) и Enter
6) Получаем

    ╔═══════ Error ════════╗
    ║ Cannot find the file ║
    ║ abc.txt ║
    ╟──────────────────────╢
    ║ { Skip } [ Cancel ] ║
    ╚══════════════════════╝


Если файлы будут с одинаковыми именами, то

    ╔═══════ Error ════════╗
    ║ Cannot copy the file ║
    ║ abc.txt ║
    ║ onto itself ║
    ╟──────────────────────╢
    ║ { OK } ║
    ╚══════════════════════╝
TagsNo tags attached.
Build2223

Relationships

related to 0001606 closed2useven10 не находит выделенный файл в директории после сохранения текста в редакторе Far 

Activities

DV

2011-06-03 10:01

reporter   bugnote:0007123

В описании бага неточность. Ошибка появляется, если пытаемся копировать файл с одной из панели при открытом и сохранённом в редакторе файле с другой панели.

2useven10

2011-06-03 10:16

developer   bugnote:0007124

Last edited: 2011-06-03 11:00

View 4 revisions

проблема в том, что при сохранении файла зовется FarChDir(strStartDir)...
2 места с комментариями //??? а нужно ли
может действительно не нужно?
надо либо выкинуть, либо в конце восстановить текущий каталог (он сохраняется).

ну или выставлять текущий каталог при переключении на панель по Ctrl-Tab
[ например в FilePanels::OnChangeFocus() вызвать ActivePanel->SetCurPath() ]

2useven10

2011-06-03 11:57

developer  

Variant1.diff (378 bytes)   
Index: fileedit.cpp
===================================================================
--- fileedit.cpp	(revision 6309)
+++ fileedit.cpp	(working copy)
@@ -1160,6 +1160,7 @@
 					}
 				}
 
+				FarChDir(strOldCurDir);
 				return TRUE;
 			}
 			// $ 30.05.2003 SVS - Shift-F4 � ���������/����� �������� ������� ������ ��������/���� (���� ����� ��������)
Variant1.diff (378 bytes)   

2useven10

2011-06-03 11:57

developer  

Variant2.diff (813 bytes)   
Index: fileedit.cpp
===================================================================
--- fileedit.cpp	(revision 6309)
+++ fileedit.cpp	(working copy)
@@ -1077,8 +1077,8 @@
 						Unquote(strSaveAsName);
 						NameChanged=StrCmpI(strSaveAsName, (Flags.Check(FFILEEDIT_SAVETOSAVEAS)?strFullFileName:strFileName));
 
-						if (!NameChanged)
-							FarChDir(strStartDir); // ������? � ����� ��???
+						//if (!NameChanged)
+						//	FarChDir(strStartDir); // ������? � ����� ��???
 
 						if (NameChanged)
 						{
@@ -1108,7 +1108,7 @@
 					}
 
 					ShowConsoleTitle();
-					FarChDir(strStartDir); //???
+					//FarChDir(strStartDir); //???
 					int SaveResult=SaveFile(strFullSaveAsName, 0, SaveAs, TextFormat, codepage, m_bAddSignature);
 
 					if (SaveResult==SAVEFILE_ERROR)
Variant2.diff (813 bytes)   

2useven10

2011-06-03 11:57

developer  

Variant3.diff (338 bytes)   
Index: filepanels.cpp
===================================================================
--- filepanels.cpp	(revision 6309)
+++ filepanels.cpp	(working copy)
@@ -1057,6 +1057,7 @@
 		    Redraw ������� ������ �� Frame::OnChangeFocus.
 		*/
 //    Redraw();
+		ActivePanel->SetCurPath();
 		Frame::OnChangeFocus(1);
 	}
 }
Variant3.diff (338 bytes)   

Maximus

2011-06-03 13:34

reporter   bugnote:0007126

кажется что FilePanels::OnChangeFocus однозначно поправить нада

2useven10

2011-10-16 09:41

developer   bugnote:0007884

build 2223

Issue History

Date Modified Username Field Change
2011-06-03 09:57 DV New Issue
2011-06-03 10:01 DV Note Added: 0007123
2011-06-03 10:16 2useven10 Note Added: 0007124
2011-06-03 10:17 2useven10 Note Edited: 0007124 View Revisions
2011-06-03 10:18 2useven10 Note Edited: 0007124 View Revisions
2011-06-03 11:00 2useven10 Note Edited: 0007124 View Revisions
2011-06-03 11:57 2useven10 File Added: Variant1.diff
2011-06-03 11:57 2useven10 File Added: Variant2.diff
2011-06-03 11:57 2useven10 File Added: Variant3.diff
2011-06-03 13:34 Maximus Note Added: 0007126
2011-10-16 09:41 2useven10 Note Added: 0007884
2011-10-16 09:43 2useven10 Assigned To => 2useven10
2011-10-16 09:43 2useven10 Status new => feedback
2011-12-23 08:58 alexy Build => 2223
2011-12-23 08:58 alexy Status feedback => closed
2011-12-23 08:58 alexy Resolution open => fixed
2011-12-23 08:58 alexy Fixed in Version => 3.0
2012-04-12 21:31 2useven10 Relationship added related to 0001606